/**
* (cl) 2009 Development Lab,
* Steve L. Nyemba, nyemba@gmail.com
*/
var jxmain={
    api:{
        cache:null,
        init:function(){
            var url = 'xml/api.xml';
            var oFn = function(xmlhttp){
                jxmain.api.cache = jx.xmlparser.parse(xmlhttp.responseXML) ;
                jxmain.api.render() ;
            }
            jx.ajax.run(url,oFn,'GET') ;

        },//-- End jxmain.api.init()
        render:function(){
            var target = "api.div" ;
            var div = null;
            var menu = new Array();
            var packages = jxmain.api.cache['groupNames'] ;
            for(var i=0; i < packages.length; i++){
                div = new Array() ;
                div.push("<div id=''") ;
                div.push(packages[i]) ;
                div.push("' >" ) ;
                //--------
                div.push("<a href=javascript:jxmain.api.read('") ;
                div.push(packages[i]) ;
                div.push("')>")


                //--------
                div.push(packages[i]) ;
                div.push("</a></div>") ;
                menu.push(div.join('')) ;
            }

            jx.dom.set(target,menu.join('')) ;
        },
        read:function(group){

            var div;
            var exists = true ;
            if(document.getElementById('dialog') == null){
                div = document.createElement('DIV') ;
                div.id = 'dialog'

                div.style.borderWidth='1px'   ;
                div.style.borderStyle='solid' ;
                div.style.width='50%';
                div.style.height='35%';
                div.style.position='absolute';
                div.style.zIndex = "0";
                div.style.top = "85";
                div.style.left= "125";


                exists = false;


            }else{
                div = document.getElementById('dialog') ;
                div.innerHTML = "";
            }

            var title   = document.createElement('DIV') ;
            title.style.backgroundColor = 'gray' ;
            title.style.color="white";
            title.innerHTML = ('<b>'+group+'</b>') ;
            var map = jxmain.api.cache[group] ;
            var content = document.createElement('DIV') ;
            var footer = document.createElement('DIV')  ;
            footer.align='center' ;


            var button  = document.createElement('INPUT') ;
            button.type = 'BUTTON'
            button.setAttribute("value","Close") ;
            button.setAttribute("onclick","jx.dom.hide('dialog')") ;

            var oPrint = document.createElement('INPUT') ;
            oPrint.type = 'BUTTON';
            oPrint.setAttribute("value","Print") ;
            oPrint.setAttribute("onclick","jx.utils.print('api.content')");

            footer.appendChild(oPrint);

            footer.appendChild(button);
            var html = new Array() ;
            var id;
            for(var i=0; i < map['ids'].length; i++){
                id  = map['ids'][i];
                html.push('<b>');
                html.push(id) ;
                html.push('</b>') ;

                html.push('<ul>') ;
                html.push(map['map'][id]) ;
                html.push('</ul>');

            }


            content.innerHTML = (html.length == 0)?"<ul>work in progress</ul>":html.join('') ;
            content.style.height='70%';
            content.style.overflow="auto";
            content.id="api.content";
            content.class="default";
            div.appendChild(title);
            div.appendChild(content);
            div.appendChild(footer);
            if(exists == false){
                var target = document.getElementById('api.div');
                target.appendChild(div);
            }
            jx.dom.show('dialog') ;
        }//-- end jxmain.api.read()
    }//-- End jxmain.api
}//-- End jxmain